//#############################################################################
//#
//#   Return to Blockland - Version 3.5
//#
//#   -------------------------------------------------------------------------
//#
//#      $Rev: 108 $
//#      $Date: 2009-09-05 11:39:30 +0100 (Sat, 05 Sep 2009) $
//#      $Author: Ephialtes $
//#      $URL: http://svn.returntoblockland.com/trunk/RTBC_ModManager.cs $
//#
//#      $Id: RTBC_ModManager.cs 108 2009-09-05 10:39:30Z Ephialtes $
//#
//#   -------------------------------------------------------------------------
//#
//#   Mod Manager (RTBMM/CModManager)
//#
//#############################################################################
//Register that this module has been loaded
$RTB::Modules::Client::ModManager = 1;

//#####################################################################################################
//
//     _____   _    _   _____   
//    / ____| | |  | | |_   _|  
//   | |  __  | |  | |   | |    
//   | | |_ | | |  | |   | |    
//   | |__| |_| |__| |_ _| |_ _ 
//    \_____(_)\____/(_)_____(_)
//
//
//##################################################################################################### 

//*********************************************************
//* Variable Declarations
//*********************************************************
$RTB::CModManager::Style::ColorDARKRED = "8B0000";
$RTB::CModManager::Style::ColorRED = "FF0000";
$RTB::CModManager::Style::ColorORANGE = "FFA500";
$RTB::CModManager::Style::ColorBROWN = "A52A2A";
$RTB::CModManager::Style::ColorYELLOW = "FFFF00";
$RTB::CModManager::Style::ColorGREEN = "008000";
$RTB::CModManager::Style::ColorOLIVE = "808000";
$RTB::CModManager::Style::ColorCYAN = "00FFFF";
$RTB::CModManager::Style::ColorBLUE = "0000FF";
$RTB::CModManager::Style::ColorDARKBLUE = "00008B";
$RTB::CModManager::Style::ColorINDIGO = "4B0082";
$RTB::CModManager::Style::ColorVIOLET = "EE82EE";
$RTB::CModManager::Style::ColorWHITE = "FFFFFF";
$RTB::CModManager::Style::ColorBLACK = "000000";

// Default BL Mods
$RTB::CModManager::DefaultBLMods = -1;
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Weapon_Sword";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Weapon_Spear";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Weapon_Rocket_Launcher";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Weapon_Push_Broom";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Weapon_Horse_Ray";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Weapon_Guns_Akimbo";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Weapon_Gun";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Weapon_Bow";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Vehicle_Tank";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Vehicle_Rowboat";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Vehicle_Pirate_Cannon";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Vehicle_Magic_Carpet";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Vehicle_Jeep";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Vehicle_Horse";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Vehicle_Flying_Wheeled_Jeep";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Vehicle_Ball";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Sound_Synth4";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Sound_Phone";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Sound_Beeps";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Script_ClearSpam";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Projectile_Radio_Wave";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Projectile_Pong";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Projectile_Pinball";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Projectile_GravityRocket";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Print_Letters_Default";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Print_2x2r_Monitor3";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Print_2x2r_Default";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Print_2x2f_Default";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Print_1x2f_Default";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Print_1x2f_BLPRemote";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Player_Quake";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Player_No_Jet";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Player_Leap_Jet";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Player_Jump_Jet";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Player_Fuel_Jet";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Particle_Tools";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Particle_Player";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Particle_Grass";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Particle_FX_Cans";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Particle_Basic";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Light_Basic";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Light_Animated";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Item_Skis";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Item_Key";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Face_Mythbusters";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Face_Jirue";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Face_Default";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Event_Camera_Control";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Emote_Love";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Emote_Hate";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Emote_Confusion";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Emote_Alarm";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Decal_WORM";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Decal_Jirue";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Decal_Hoodie";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Decal_Default";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Brick_V15";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Brick_Treasure_Chest";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Brick_Teledoor";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Brick_Large_Cubes";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Brick_Halloween";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Brick_Doors";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Brick_Christmas_Tree";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Brick_Checkpoint";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Brick_Arch";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Bot_Zombie";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Bot_Shark";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Bot_Horse";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Bot_Hole";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Bot_Blockhead";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "Colorset_Default";
$RTB::CModManager::DefaultBLMod[$RTB::CModManager::DefaultBLMods++] = "System_ReturnToBlockland";

//*********************************************************
//* GUI Callbacks
//*********************************************************
//- RTB_ModManager::onWake (GUI wake callback, updates browser buttons + auth)
function RTB_ModManager::onWake(%this)
{
   if(!%this.isOpen())
      return;
      
   RTBMM_Zones_CheckButtons();
  
   if(AddOnsGui.isAwake())
      AddOnsGui.onSleep();
   
   if(!$RTB::CModManager::Cache::OpenDirect)
      RTBMM_Zones_Refresh();
      
   if($RTB::CModManager::Cache::CurrentZone $= "")
      RTBMM_ModsView_Init("sections");
   
   if($AddOn__Weapon_Gun $= "")
      clientUpdateAddonsList();   
   
   if(!RTBMM_FileCache.refreshed)
      RTBMM_FileCache.refresh();
   
   if(!RTBMM_GroupManager.loaded)
      RTBMM_GroupManager.loadDat();
}

//- RTB_ModManager::onSleep (GUI sleep callback)
function RTB_ModManager::onSleep()
{
}

//*********************************************************
//* Forward/Backward Tracking
//*********************************************************
//- RTBMM_Zones_Track (Tracks current zone and return eval)
function RTBMM_Zones_Track(%zone,%return,%pagination)
{
   if(!isObject(RTBMM_ZoneTracker))
   {
      new ScriptObject(RTBMM_ZoneTracker)
      {
         currZone = -1;
         numZones = 0;
      };
      RTBGroup.add(RTBMM_ZoneTracker);
   }
   
   //I have run out of milkshake so thats why the tracking queue will have to
   //be of an indeterminate length... can't work without milkshake
   if(RTBMM_ZoneTracker.zoneCmd[RTBMM_ZoneTracker.currZone] !$= %return)
   {
      RTBMM_ZoneTracker.currZone++;
      RTBMM_ZoneTracker.zone[RTBMM_ZoneTracker.currZone] = %zone;
      RTBMM_ZoneTracker.zoneCmd[RTBMM_ZoneTracker.currZone] = %return;
      RTBMM_ZoneTracker.numZones = RTBMM_ZoneTracker.currZone+1;
   }
   $RTB::CModManager::Cache::CurrentZone = %zone;
   $RTB::CModManager::Cache::PaginationTemplate = %pagination;
   
   RTBMM_Zones_CheckButtons();
}

//- RTBMM_Zones_Back (Moves back in history)
function RTBMM_Zones_Back()
{
   if(RTBMM_ZoneTracker.currZone >= 1)
   {
      RTBMM_ZoneTracker.currZone--;
      %return = RTBMM_ZoneTracker.zoneCmd[RTBMM_ZoneTracker.currZone];
      eval(%return);
   }
   RTBMM_Zones_CheckButtons();
}

//- RTBMM_Zones_Forward (Moves forward in history)
function RTBMM_Zones_Forward()
{
   if(RTBMM_ZoneTracker.currZone < (RTBMM_ZoneTracker.numZones-1))
   {
      RTBMM_ZoneTracker.currZone++;
      %return = RTBMM_ZoneTracker.zoneCmd[RTBMM_ZoneTracker.currZone];
      eval(%return);
   }
   RTBMM_Zones_CheckButtons();
}

//- RTBMM_Zones_Refresh (Refreshes current page)
function RTBMM_Zones_Refresh()
{
   if(RTBMM_ZoneTracker.numZones >= 1)
   {
      %return = RTBMM_ZoneTracker.zoneCmd[RTBMM_ZoneTracker.currZone];
      eval(%return);
   }
}

//- RTBMM_Zones_CheckButtons (checks to see if buttons should be active)
function RTBMM_Zones_CheckButtons()
{
   RTBMM_HistoryBack.setActive(0);
   RTBMM_HistoryForward.setActive(0);
   RTBMM_Refresh.setActive(1);
   
   if(RTBMM_ZoneTracker.numZones > 1)
   {
      if(RTBMM_ZoneTracker.currZone < (RTBMM_ZoneTracker.numZones-1))
         RTBMM_HistoryForward.setActive(1);
         
      if(RTBMM_ZoneTracker.currZone >= 1)
         RTBMM_HistoryBack.setActive(1);
   }
   
   if(RTBMM_ZoneTracker.currZone $= "")
      RTBMM_Refresh.setActive(0);
}

//*********************************************************
//* Package
//*********************************************************
package RTBC_ModManager
{
   function clientUpdateAddonsList()
   {
      if($AddOn__Weapon_Gun $= "")
         Parent::clientUpdateAddonsList();
   }
};
activatePackage(RTBC_ModManager);

//*********************************************************
//* GUI Generation Management
//*********************************************************
//- RTBMM_GUI_Init (Creates intial gui for building into)
function RTBMM_GUI_Init()
{
   if(isObject(RTBMM_LoadingContentSwatch))
      RTBMM_LoadingContentSwatch.delete();
   
   $RTB::CModManager::GUI::CurrentY = 0;
   
   if(isObject(RTBMM_WindowSwatch))
      RTBMM_WindowSwatch.delete();
      
   RTBMM_WindowOverlay.clear();
   RTBMM_WindowOverlay.setVisible(0);
      
   %swatch = new GuiSwatchCtrl(RTBMM_WindowSwatch)
   {
      position = "1 1";
      extent = "679 555";
      color = "255 255 255 255";
   };
   RTBMM_ModWindow.add(%swatch);
}

//- RTBMM_GUI_PushControl (Adds control to the swatch)
function RTBMM_GUI_PushControl(%ctrl,%recalc)
{
   if(!isObject(RTBMM_WindowSwatch))
      RTBMM_GUI_Init();
      
   RTBMM_WindowSwatch.add(%ctrl);
   
   if(%recalc)
   {
      %totalOffset = getWord(%ctrl.position,1) + getWord(%ctrl.extent,1);
      $RTB::CModManager::GUI::CurrentY = %totalOffset;
      RTBMM_GUI_Resize();
   }
}

//- RTBMM_GUI_Resize (Resizes swatch based on Y variable)
function RTBMM_GUI_Resize()
{
	%PosX = getWord(RTBMM_WindowSwatch.position,0);
	%PosY = getWord(RTBMM_WindowSwatch.position,1);
	%ExtX = "679";
   %ExtY = 555;
   
   if($RTB::CModManager::GUI::CurrentY > %ExtY)
      %ExtY = $RTB::CModManager::GUI::CurrentY-1;
      
   RTBMM_WindowSwatch.resize(%PosX,%PosY,%ExtX,%ExtY);
}

//- RTBMM_GUI_AutoResize (Resizes swatch to fit gui inside)
function RTBMM_GUI_AutoResize()
{
	%PosX = getWord(RTBMM_WindowSwatch.position,0);
	%PosY = getWord(RTBMM_WindowSwatch.position,1);
	%ExtX = "679";
   %ExtY = 555;
   
   for(%i=0;%i<RTBMM_WindowSwatch.getCount();%i++)
   {
      %ctrl = RTBMM_WindowSwatch.getObject(%i);
      %extent = getWord(%ctrl.position,1) + getWord(%ctrl.extent,1);
      if(%extent > %ExtY)
         %ExtY = %extent-1;
   }
	RTBMM_WindowSwatch.resize(%PosX,%PosY,%ExtX,%ExtY);
	
	%ExtY = 1;
   for(%i=0;%i<RTBMM_WindowSwatch.getCount();%i++)
   {
      %ctrl = RTBMM_WindowSwatch.getObject(%i);
      %extent = getWord(%ctrl.position,1) + getWord(%ctrl.extent,1);
      if(%extent > %ExtY)
         %ExtY = %extent;
   }	
	$RTB::CModManager::GUI::CurrentY = %ExtY;
}

//- RTBMM_GUI_Offset (Offsets GUI in either direction and updates controls)
function RTBMM_GUI_Offset(%offset)
{
   $RTB::CModManager::GUI::CurrentY += %offset;
   RTBMM_GUI_Resize();
}

//- RTBMM_GUI_FadeIn (Fades a swatch in)
function RTBMM_GUI_FadeIn(%ctrl)
{
   if(!isObject(%ctrl))
      return;
      
   %color = getWords(%ctrl.color,0,2);
   %alpha = getWord(%ctrl.color,3);
   %alpha += 20;
   if(%alpha > 255)
      %alpha = 255;
   %ctrl.color = %color SPC %alpha;
   
   if(%alpha < 255)
      schedule(50,0,"RTBMM_GUI_FadeIn",%ctrl);
}

//- RTBMM_GUI_FadeOut (Fades out a swatch)
function RTBMM_GUI_FadeOut(%ctrl)
{
   if(!isObject(%ctrl))
      return;
      
   %color = getWords(%ctrl.color,0,2);
   %alpha = getWord(%ctrl.color,3);
   %alpha -= 20;
   if(%alpha < 0)
      %alpha = 0;
   %ctrl.color = %color SPC %alpha;
   
   if(%alpha > 0)
      schedule(50,0,"RTBMM_GUI_FadeOut",%ctrl);
}

//- RTBMM_GUI_Load (Shows a loading gui)
function RTBMM_GUI_Load(%text)
{
   RTBMM_WindowOverlay.clear();
   RTBMM_WindowOverlay.setVisible(0);
   
   if(!isObject(RTBMM_WindowSwatch))
   {
      RTBMM_GUI_Init();
      RTBMM_WindowSwatch.color = "0 0 0 0";
   }
      
   if(isObject(RTBMM_LoadingContentSwatch))
      RTBMM_LoadingContentSwatch.delete();
      
   if(%text $= "")
      %text = "Downloading Content...";
      
	%swatch = new GuiSwatchCtrl(RTBMM_LoadingContentSwatch)
	{
	   position = "100 35";
		extent = "679 555";
		color = "255 255 255 150";
		
		new GuiAnimatedBitmapCtrl()
		{
		   horizSizing = "center";
		   vertSizing = "bottom";
		   position = "324 240";
		   extent = "31 31";
		   bitmap = $RTB::Path@"images/ui/animated/loadRing";
		   framesPerSecond = 15;
		   numFrames = 8;
		};
		
		new GuiMLTextCtrl()
		{
		   horizSizing = "center";
		   position = "140 275";
		   extent = "400 12";
		   profile = RTB_Verdana12Pt;
		   text = "<just:center><color:555555>"@%text;
		};
	};
   RTBMM_GUI_PushControl(%swatch);
   RTB_ModManager.add(%swatch);
}

//- RTBMM_GUI_FailLoad (Shows a failed loading gui)
function RTBMM_GUI_FailLoad(%text)
{
   if(isObject(RTBMM_LoadingContentSwatch))
      RTBMM_LoadingContentSwatch.delete();
      
   if(%text $= "")
      %text = "An Error Occurred";
      
	%swatch = new GuiSwatchCtrl(RTBMM_LoadingContentSwatch)
	{
	   fixedPosition = "1 1";
		extent = "680 553";
		color = "235 235 235 255";
		
		new GuiBitmapCtrl()
		{
		   horizSizing = "center";
		   vertSizing = "bottom";
		   position = "324 240";
		   extent = "31 31";
		   bitmap = $RTB::Path@"images/ui/animated/loadRing_fail";
		};
		
		new GuiMLTextCtrl()
		{
		   horizSizing = "center";
		   position = "40 275";
		   extent = "600 12";
		   profile = RTB_Verdana12Pt;
		   text = "<just:center><color:555555>"@%text;
		};
	};
   RTBMM_GUI_PushControl(%swatch);
}

//- RTBMM_GUI_AnimateStar_Init (Fills a star progressively)
function RTBMM_GUI_AnimateStar_Init(%ctrl,%stage)
{
   if(!isObject(%ctrl))
      return;
      
   if(!RTBCO_getPref("MM::Animate"))
   {
      %ctrl.setBitmap($RTB::Path@"images/icons/star"@%stage);
      return;
   }
      
   %ctrl.currStage = 0;
   RTBMM_GUI_AnimateStar_Action(%ctrl,%stage);
}

//- RTBMM_GUI_AnimateStar_Action (Action for star filling)
function RTBMM_GUI_AnimateStar_Action(%ctrl,%stage)
{
   if(!isObject(%ctrl))
      return;
      
   %ctrl.setBitmap($RTB::Path@"images/icons/star"@%ctrl.currStage);
   
   if(%ctrl.currStage >= %stage)
      return;
   
   %ctrl.currStage++;
   schedule(50,0,"RTBMM_GUI_AnimateStar_Action",%ctrl,%stage);
}

//- RTBMM_GUI_LoadRing_Clear (Clears loadring and schedule)
function RTBMM_GUI_LoadRing_Clear(%ctrl)
{
   %bitmap = new GuiBitmapCtrl()
   {
      position = %ctrl.position;
      extent = %ctrl.extent;
      bitmap = $RTB::Path@"images/ui/animated/loadRing_clear";
   };
   %ctrl.getGroup().add(%bitmap);
   %ctrl.delete();
}

//*********************************************************
//* GUI Positioning Functions
//*********************************************************
//- RTBMM_GUI_CenterVert (Centers ctrlA inside ctrlB)
function RTBMM_GUI_CenterVert(%ctrlA,%ctrlB)
{
   if(isObject(%ctrlB))
   {
      %maxArea = getWord(%ctrlB.extent,1);
      %height = getWord(%ctrlA.extent,1);

      %yPosition = (%maxArea/2)-(%height/2);
      if(%ctrlB $= %ctrlA.getGroup())
         %ctrlA.position = getWord(%ctrlA.position,0) SPC (%yPosition+getWord(%ctrlB.position,1));
      else
         %ctrlA.position = getWord(%ctrlA.getCanvasPosition(),0) SPC (%yPosition+getWord(%ctrlB.getCanvasPosition(),1));
   }
   else
   {
      %ctrlB = %ctrlA.getGroup();
      %maxArea = getWord(%ctrlB.extent,1);
      %height = getWord(%ctrlA.extent,1);
      
      %yPosition = (%maxArea/2)-(%height/2);
      %ctrlA.position = getWord(%ctrlA.position,0) SPC %yPosition;
   }
}

//- RTBMM_GUI_CenterHoriz (Centers ctrlA inside ctrlB)
function RTBMM_GUI_CenterHoriz(%ctrlA,%ctrlB)
{
   if(isObject(%ctrlB))
   {
      %maxArea = getWord(%ctrlB.extent,0);
      %width = getWord(%ctrlA.extent,0);
      
      %xPosition = (%maxArea/2)-(%width/2);
      if(%ctrlB $= %ctrlA.getGroup())
         %ctrlA.position = (%xPosition+getWord(%ctrlB.position,0)) SPC getWord(%ctrlA.position,1);
      else
         %ctrlA.position = (%xPosition+getWord(%ctrlB.getCanvasPosition(),0)) SPC getWord(%ctrlA.getCanvasPosition(),1);
   }
   else
   {
      %ctrlB = %ctrlA.getGroup();
      %maxArea = getWord(%ctrlB.extent,0);
      %width = getWord(%ctrlA.extent,0);
      
      %xPosition = (%maxArea/2)-(%width/2);
      %ctrlA.position = %xPosition SPC getWord(%ctrlA.position,1);
   }
}

//- RTBMM_GUI_Center (Centers ctrlA inside ctrlB)
function RTBMM_GUI_Center(%ctrlA,%ctrlB)
{
   RTBMM_GUI_CenterHoriz(%ctrlA,%ctrlB);
   RTBMM_GUI_CenterVert(%ctrlA,%ctrlB);
}

//*********************************************************
//* Public GUI Generation Functions
//*********************************************************
//- RTBMM_GUI_createWindow (Creates an imitation GuiWindowCtrl comprised of resizable bitmaps)
function RTBMM_GUI_createWindow(%text)
{
   RTBMM_WindowOverlay.setVisible(1);
   
   %window = new GuiSwatchCtrl()
   {
      extent = "64 64";
      color = "0 0 0 0";
      
      new GuiBitmapCtrl()
      {
         extent = "6 28";
         minExtent = "1 1";
         bitmap = $RTB::Path@"images/ui/window_topLeft";
      };
      
      new GuiBitmapCtrl()
      {
         position = "6 0";
         extent = "53 28";
         horizSizing = "width";
         bitmap = $RTB::Path@"images/ui/window_topLoop";
         wrap = 1;
      };
      
      new GuiBitmapCtrl()
      {
         position = "59 0";
         extent = "5 28";
         minExtent = "1 1";
         horizSizing = "left";
         bitmap = $RTB::Path@"images/ui/window_topRight";
      };
      
      new GuiSwatchCtrl()
      {
         position = "4 31";
         extent = "56 29";
         horizSizing = "width";
         vertSizing = "height";
         color = "235 236 237 255";
      };
      
      new GuiBitmapCtrl()
      {
         position = "0 28";
         extent = "6 5";
         minExtent = "1 1";
         bitmap = $RTB::Path@"images/ui/content_topLeft";
      };
      
      new GuiBitmapCtrl()
      {
         position = "6 28";
         extent = "52 3";
         minExtent = "1 1";
         horizSizing = "width";
         bitmap = $RTB::Path@"images/ui/content_top";
         wrap = 1;
      };
      
      new GuiBitmapCtrl()
      {
         position = "58 28";
         extent = "6 5";
         minExtent = "1 1";
         horizSizing = "left";
         bitmap = $RTB::Path@"images/ui/content_topRight";
      };
      
      new GuiBitmapCtrl()
      {
         position = "0 33";
         extent = "4 24";
         minExtent = "1 1";
         vertSizing = "height";
         bitmap = $RTB::Path@"images/ui/content_left";
         wrap = 1;
      };
      
      new GuiBitmapCtrl()
      {
         position = "60 33";
         extent = "4 24";
         minExtent = "1 1";
         horizSizing = "left";
         vertSizing = "height";
         bitmap = $RTB::Path@"images/ui/content_right";
         wrap = 1;
      };
      
      new GuiBitmapCtrl()
      {
         position = "0 57";
         extent = "7 7";
         minExtent = "1 1";
         vertSizing = "top";
         bitmap = $RTB::Path@"images/ui/content_bottomLeft";
      };
      
      new GuiBitmapCtrl()
      {
         position = "57 57";
         extent = "7 7";
         minExtent = "1 1";
         horizSizing = "left";
         vertSizing = "top";
         bitmap = $RTB::Path@"images/ui/content_bottomRight";
      };
      
      new GuiBitmapCtrl()
      {
         position = "7 60";
         extent = "50 4";
         minExtent = "1 1";
         horizSizing = "width";
         vertSizing = "top";
         bitmap = $RTB::Path@"images/ui/content_bottom";
         wrap = 1;
      };
      
      new GuiMLTextCtrl()
      {
         position = "3 5";
         extent = "390 18";
         text = "<color:FAFAFA><just:left><font:Impact:18>  "@%text;
      };
      
      new GuiBitmapButtonCtrl()
      {
         position = "41 7";
         extent = "16 16";
         bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/close";
         horizSizing = "left";
         text = " ";
      };
   };
   %window.canvas = %window.getObject(3);
   
   %window.getObject(%window.getCount()-1).command = "RTBMM_GUI_closeWindow("@%window@");";
   %window.closeButton = %window.getObject(%window.getCount()-1);
   RTBMM_WindowOverlay.add(%window);
   
   return %window;
}

//- RTBMM_GUI_closeWindow (Closes a generated window and removes the overlay if necessary)
function RTBMM_GUI_closeWindow(%window)
{
   %window.delete();
   if(RTBMM_WindowOverlay.getCount() <= 0)
      RTBMM_WindowOverlay.setVisible(0);
}

//- RTBMM_GUI_createMessageBoxOK (Creates an OK message box from the above function)
function RTBMM_GUI_createMessageBoxOK(%title,%message,%ok)
{
   %window = RTBMM_GUI_createWindow(%title);
   %window.resize(0,0,300,100);
   RTBMM_GUI_Center(%window);
   
   %text = new GuiMLTextCtrl()
   {
      position = "10 10";
      extent = "275 12";
      text = "<font:Verdana:12><color:555555>"@%message;
   };
   %window.canvas.add(%text);
   %text.forceReflow();
   
   %button = new GuiBitmapButtonCtrl()
   {
      position = "0 35";
      vertSizing = "top";
      extent = "58 25";
      text = " ";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/ok";
      command = %ok@"RTBMM_GUI_closeWindow("@%window@");";
   };
   %window.canvas.add(%button);
   RTBMM_GUI_CenterHoriz(%button);
   
   %window.resize(0,0,300,getWord(%text.extent,1)+85);
   RTBMM_GUI_Center(%window);
}

//- RTBMM_GUI_createMessageBoxOKCancel (Creates an OK/Cancel message box from the above function)
function RTBMM_GUI_createMessageBoxOKCancel(%title,%message,%ok,%cancel)
{
   %window = RTBMM_GUI_createWindow(%title);
   %window.resize(0,0,300,100);
   RTBMM_GUI_Center(%window);
   
   %text = new GuiMLTextCtrl()
   {
      position = "10 10";
      extent = "275 12";
      text = "<font:Verdana:12><color:555555>"@%message;
   };
   %window.canvas.add(%text);
   %text.forceReflow();
   
   %button = new GuiBitmapButtonCtrl()
   {
      position = "88 35";
      vertSizing = "top";
      extent = "58 25";
      text = " ";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/ok";
      command = %ok@"RTBMM_GUI_closeWindow("@%window@");";
   };
   %window.canvas.add(%button);
   
   %button = new GuiBitmapButtonCtrl()
   {
      position = "150 35";
      vertSizing = "top";
      extent = "58 25";
      text = " ";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/cancel";
      command = %cancel@"RTBMM_GUI_closeWindow("@%window@");";
   };
   %window.canvas.add(%button);
   
   %window.resize(0,0,300,getWord(%text.extent,1)+85);
   RTBMM_GUI_Center(%window);
}

//- RTBMM_GUI_createHeader (Creates a standard header with value)
function RTBMM_GUI_createHeader(%type,%text)
{
   if(%type $= "")
      %type = 1;
     
   if(%type $= 1)
   {
      %borderProfile = RTBMM_CellLightProfile;
      %bitmapBackground = $RTB::Path@"images/ui/header_light";
   }
   else
   {
      %borderProfile = RTBMM_CellDarkProfile;
      %bitmapBackground = $RTB::Path@"images/ui/header_dark";
   }
      
   %header = new GuiBitmapCtrl()
   {
      position = 0 SPC $RTB::CModManager::GUI::CurrentY;
      extent = 680 SPC 28;
      bitmap = %bitmapBackground;
      wrap = 1;
      
      new GuiBitmapBorderCtrl()
      {
         profile = %borderProfile;
         horizSizing = "width";
         vertSizing = "height";
         position = 0 SPC 0;
         extent = 680 SPC 28;
      };
   };
   
   if(%text $= "")
   {
      RTBMM_GUI_PushControl(%header,1);
      return %header;
   }
   
   %ml = new GuiMLTextCtrl()
   {
      profile = RTBMM_PaginationProfile;
      position = "0 0";
      extent = "678 28";
      text = "<color:888888><font:Arial Bold:15><just:center>"@%text;
   };
   %header.add(%ml);
   RTBMM_GUI_PushControl(%header,1);
   
   %ml.forceReflow();
   RTBMM_GUI_Center(%ml);
   
   return %header;
}

//- RTBMM_GUI_createContent (creates a content row)
function RTBMM_GUI_createContent(%type,%height,%width1,%width2,%width3,%width4,%width5,%width6,%width7,%width8,%maxWidth)
{
   if(%type $= "")
      %type = 1;
      
   if(%type $= 1)
   {
      %bitmapBackground = $RTB::Path@"images/ui/cell_gray";
      %borderProfile = RTBMM_CellLightProfile;
   }
   else if(%type $= 2)
   {
      %bitmapBackground = $RTB::Path@"images/ui/cell_yellow";
      %borderProfile = RTBMM_CellYellowProfile;
   }
   
   if(%width1 $= "")
   {
      %width1 = 100;
      %width2 = "";
   }
      
   if(%height $= "")
      %height = 30;
      
   %i = 1;
   while(%width[%i] !$= "")
   {
      %i++;
   }
   %count = %i-1;
   
   if(%maxWidth $= "")
      %maxWidth = 680;

   %container = new GuiBitmapCtrl()
   {
      position = "0" SPC $RTB::CModManager::GUI::CurrentY;
      extent = %maxWidth SPC %height;
      bitmap = %bitmapBackground;
   };

   %currX = 0;
   for(%i=1;%i<%count+1;%i++)
   {
      %width = (%maxWidth/100)*%width[%i];
      if(strPos(%width,".") >= 0)
         %decimal = getSubStr(%width,strPos(%width,".")+1,strLen(%width));
      %width = mFloor(%width);
      %decimal = "0."@%decimal;

      %remainder += %decimal;
      %remainder = mFloatLength(%remainder,2);
      if(%remainder >= 1)
      {
         %remainder -= 1;
         %header.extent = getWord(%header.extent,0)+1 SPC %height;
         %currX += 1;
      }

      %header = new GuiBitmapBorderCtrl()
      {
         profile = %borderProfile;
         horizSizing = "width";
         vertSizing = "height";
         position = %currX SPC 0;
         extent = %width SPC %height;
      };
      %currX += (%width);
      %container.add(%header);
   }
   RTBMM_GUI_PushControl(%container,1);
   
   if(mFloatLength(%remainder,0) >= 1)
   {
      %header.extent = getWord(%header.extent,0)+1 SPC %height;
      %header.getObject(0).extent = getWord(%header.extent,0)+1 SPC %height-1;
      %header.getObject(0).getObject(0).extent = getWord(%header.extent,0)-2 SPC %height-2;
   }
   
   return %container;
}

//- RTBMM_GUI_createSplitHeader (creates a percentage-split header)
function RTBMM_GUI_createSplitHeader(%type,%width1,%text1,%width2,%text2,%width3,%text3,%width4,%text4,%width5,%text5,%width6,%text6,%width7,%text7,%width8,%text8)
{
   if(%type $= "")
      %type = 1;
      
   if(%type $= 1)
   {
      %bitmapBackground = $RTB::Path@"images/ui/header_light";
      %borderProfile = RTBMM_CellLightProfile;
   }
   else
   {
      %bitmapBackground = $RTB::Path@"images/ui/header_dark";
      %borderProfile = RTBMM_CellDarkProfile;
   }
      
   %i = 1;
   while(%width[%i] !$= "")
   {
      %i++;
   }
   %count = %i-1;
   
   %height = 28;
   %maxWidth = 680;

   %container = new GuiBitmapCtrl()
   {
      position = "0" SPC $RTB::CModManager::GUI::CurrentY;
      extent = %maxWidth SPC %height;
      bitmap = %bitmapBackground;
      wrap = 1;
   };

   %currX = 0;
   for(%i=1;%i<%count+1;%i++)
   {
      %width = (%maxWidth/100)*%width[%i];
      if(strPos(%width,".") >= 0)
         %decimal = getSubStr(%width,strPos(%width,".")+1,strLen(%width));
      %width = mFloor(%width);
      %decimal = "0."@%decimal;

      %remainder += %decimal;
      %remainder = mFloatLength(%remainder,2);
      if(%remainder >= 1)
      {
         %remainder -= 1;
         %header.extent = getWord(%header.extent,0)+1 SPC %height;
         %currX += 1;
      }

      %header = new GuiBitmapBorderCtrl()
      {
         profile = %borderProfile;
         horizSizing = "width";
         vertSizing = "height";
         position = %currX SPC 0;
         extent = %width SPC %height;
      };
      %currX += %width;
      %container.add(%header);
      
      if(%text[%i] !$= "")
      {
         %ml = new GuiMLTextCtrl()
         {
            profile = RTBMM_PaginationProfile;
            position = "0 6";
            vertSizing = "width";
            extent = %width SPC %height;
            text = "<color:888888><font:Arial Bold:15><just:center>"@%text[%i];
         };
         %header.add(%ml);
      }
   }
   RTBMM_GUI_PushControl(%container,1);
   
   if(mFloatLength(%remainder,0) >= 1)
   {
      %header.extent = getWord(%header.extent,0)+1 SPC %height;
      %header.getObject(0).extent = getWord(%header.extent,0)+1 SPC %height-1;
      %header.getObject(0).getObject(0).extent = getWord(%header.extent,0)-2 SPC %height-2;
   }
   
   return %container;
}

//- RTBMM_GUI_createFooter (Creates a footer, and adds pagination if necessary)
function RTBMM_GUI_createFooter(%type)
{      
   %pages = $RTB::CModManager::Cache::Pagination::NumPages;
   %currPage = $RTB::CModManager::Cache::Pagination::CurrPage;
   
   if(%pages <= 1)
   {
      RTBMM_GUI_createSplitHeader(2,"100"," ");   
      return;
   }
 
   %paginationText = "Goto Page ";
   if(%currPage > 1)
      %paginationText = %paginationText @ "<a:pagination-"@%currPage-1@">Previous</a> ";
   %paginationText = %paginationText @ ((%currPage $= 1) ? "<spush><color:666666><font:Verdana Bold:15>[1]<spop>" : "<a:pagination-1>1</a>");
 
   if(%pages > 5)
   {
      %start = getMin(getMax(1, %currPage-4), %pages-5);
      %end = getMax(getMin(%pages, %currPage+4), 6);
      
      %paginationText = %paginationText @ ((%start > 1) ? " <spush><color:DDDDDD><font:Verdana Bold:15>...<spop> " : " ");
      
      for(%i=%start+1;%i<%end;%i++)
      {
         %paginationText = %paginationText @ ((%currPage $= %i) ? "<spush><color:666666><font:Verdana Bold:15>["@%i@"]<spop>" : "<a:pagination-"@%i@">"@%i@"</a>");
         if(%i < %end-1)
            %paginationText = %paginationText @ " ";
      }
      
      %paginationText = %paginationText @ ((%end < %pages) ? " <spush><color:DDDDDD><font:Verdana Bold:15>...<spop> " : " ");
   }
   else
   {
      %paginationText = %paginationText @ " ";
      
      for(%i=2;%i<%pages;%i++)
      {
         %paginationText = %paginationText @ ((%currPage $= %i) ? "<spush><color:666666><font:Verdana Bold:15>["@%i@"]<spop>" : "<a:pagination-"@%i@">"@%i@"</a>");
         if(%i < %pages)
            %paginationText = %paginationText @ " ";
      }
   }
   %paginationText = %paginationText @ ((%currPage $= %i) ? "<spush><color:666666><font:Verdana Bold:15>["@%pages@"]<spop>" : "<a:pagination-"@%pages@">"@%pages@"</a>");
   
   if(%currPage < %pages)
      %paginationText = %paginationText @ " <a:pagination-"@%currPage+1@">Next</a>";
   
   RTBMM_GUI_createHeader(2,"<font:Verdana Bold:13><color:333333><just:right>"@%paginationText@"  ");
}

//- RTBMM_GUI_getXPlacement (Calculates next placement from supplied control)
function RTBMM_GUI_getXPlacement(%ctrl)
{
   %xPlace = getWord(%ctrl.position,0)+(getWord(%ctrl.extent,0));
   return %xPlace;
}

//- RTBMM_GUI_calcGUIContainer (Calculates extent of container to surround supplied controls)
function RTBMM_GUI_calcGUIContainer(%ctrl1,%ctrl2,%ctrl3,%ctrl4,%ctrl5,%ctrl6,%ctrl7,%ctrl8)
{
   %i = 1;
   while(%ctrl[%i] !$= "")
   {
      if(getWord(%ctrl[%i].position,0)+getWord(%ctrl[%i].extent,0) > %xMax)
         %xMax = getWord(%ctrl[%i].position,0)+getWord(%ctrl[%i].extent,0);
      if(getWord(%ctrl[%i].extent,1) > %yMax)
         %yMax = getWord(%ctrl[%i].extent,1);
         
      %i++;
   }
   
   %xMax++;
   %yMax+=2;
   return %xMax SPC %yMax;
}

//- RTBMM_GUI_calcWidthPercent (Calculates width from percentage)
function RTBMM_GUI_calcWidthPercent(%target,%width1,%width2,%width3,%width4,%width5,%width6,%width7,%width8)
{
   %i = 1;
   while(%width[%i] !$= "")
   {
      %i++;
   }
   %count = %i-1;
   %maxWidth = 680-(%count+1);
   
   for(%i=1;%i<%count+1;%i++)
   {
      %actualWidth[%i] = (%maxWidth/100)*%width[%i];
      if(strPos(%actualWidth[%i],".") >= 0)
         %decimal = getSubStr(%actualWidth[%i],strPos(%actualWidth[%i],".")+1,strLen(%actualWidth[%i]));
      %actualWidth[%i] = mFloor(%actualWidth[%i]);
      
      %decimal = "0."@%decimal;
      %remainder += %decimal;
      %remainder = mFloatLength(%remainder,1);
      if(%remainder >= 1)
      {
         %remainder -= 1;
         %actualWidth[%i-1] = %actualWidth[%i-1]+1;
      }
   }
   return %actualWidth[%target];
}

//*********************************************************
//* Mods View
//*********************************************************
//- RTBMM_ModsView_Init (Entrance)
function RTBMM_ModsView_Init(%mode)
{
   RTBMM_GUI_Init();
 
   RTBMM_Zones_Track("ModsView","RTBMM_ModsView_Init(\""@%mode@"\");");
   
   %header = RTBMM_GUI_createHeader(2,"<color:FAFAFA><just:left><font:Impact:18>  Your Mods");
   
   %expandBtn = new GuiBitmapButtonCtrl()
   {
      position = "399 4";
      extent = "68 18";
      text = " ";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/expand";
      command = "RTBMM_ModsView_ExpandAll();";
   };
   %header.add(%expandBtn);
   
   %collapseBtn = new GuiBitmapButtonCtrl()
   {
      position = "468 4";
      extent = "68 18";
      text = " ";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/collapse";
      command = "RTBMM_ModsView_CollapseAll();";
   };
   %header.add(%collapseBtn);
   
   %sectionsBtn = new GuiBitmapButtonCtrl()
   {
      position = "537 4";
      extent = "68 18";
      text = " ";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/sections";
      command = "RTBMM_ModsView_Init(\"sections\");";
   };
   %header.add(%sectionsBtn);
   
   %groupsBtn = new GuiBitmapButtonCtrl()
   {
      position = "606 4";
      extent = "68 18";
      text = " ";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/groups";
      command = "RTBMM_ModsView_Init(\"groups\");";
   };
   %header.add(%groupsBtn);
   
   $RTB::CModManager::Cache::SectionHeader = %header;
   
   if(%mode $= "groups")
      RTBMM_ModsView_InitGroupsView();
   else
      RTBMM_ModsView_InitSectionView();

   $RTB::CModManager::Cache::Section[$RTB::CModManager::Cache::NumSections] = RTBMM_GUI_createHeader(2," ");
   $RTB::CModManager::Cache::NumSections++;
}

//- RTBMM_ModsView_InitSectionView (section-based view of add-ons)
function RTBMM_ModsView_InitSectionView()
{
   %header = $RTB::CModManager::Cache::SectionHeader;
   
   %syncBtn = new GuiBitmapButtonCtrl()
   {
      position = "184 4";
      extent = "68 18";
      text = " ";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/sync";
      command = "RTBMM_ModsView_syncAddons();";
   };
   %header.add(%syncBtn);
   
   %enableBtn = new GuiBitmapButtonCtrl()
   {
      position = "261 4";
      extent = "68 18";
      text = " ";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/enableAll";
      command = "RTBMM_ModsView_EnableAll();";
   };
   %header.add(%enableBtn);
   
   %disableBtn = new GuiBitmapButtonCtrl()
   {
      position = "330 4";
      extent = "68 18";
      text = " ";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/disableAll";
      command = "RTBMM_ModsView_DisableAll();";
   };
   %header.add(%disableBtn);   
   
   $RTB::CModManager::Cache::NumSections = 0;
   
   %sections = 0;
   for(%i=0;%i<RTBMM_FileCache.getCount();%i++)
   {
      %file = RTBMM_FileCache.getObject(%i);
      %type = %file.file_type;
      
      if(!%added[%type])
      {
         %added[%type] = 1;
         %files[%type] = 0;
         %section[%sections++] = %type;
      }
      %file[%files[%type]++,%type] = %file;
   }
   
   %sortString = "";      
   for(%i=1;%i<%sections+1;%i++)
   {
      %sortString = %sortString@%i@"=>"@%section[%i]@",";
   }
   %sortString = getSubStr(%sortString,0,strLen(%sortString)-1);
   %sortString = strReplace(sortFields(%sortString),",","\t");
   
   %k = 0;
   for(%i=0;%i<getFieldCount(%sortString);%i++)
   {
      %block = strReplace(getField(%sortString,%i),"=>","\t");
      %key = getField(%block,0);
      %value = getField(%block,1);
      %section[%k++] = %value;
   }
   
   %collapse = 0;
   if($RTB::CModManager::SectionCollapsed["Default Add-Ons"] $= "" || $RTB::CModManager::SectionCollapsed["Default Add-Ons"] $= 1)
         %collapse = 1;
   RTBMM_ModsView_createSectionRow("Default Add-Ons",%collapse);
   
   for(%i=1;%i<%sections+1;%i++)
   {
      if(%section[%i] $= "RTB2 Add-Ons")
         %hasRTB2AddOns = 1;
      if(%section[%i] $= "Non-RTB Add-Ons")
         %hasNonRTBAddOns = 1;
      if(%section[%i] $= "Unpackaged Add-Ons")
         %hasUnpackagedAddOns = 1;
      if(%section[%i] $= "Content-Only Add-Ons")
         %hasContentOnlyAddOns = 1;
      if(%section[%i] $= "Default Add-Ons" || %section[%i] $= "Non-RTB Add-Ons" || %section[%i] $= "RTB2 Add-Ons" || %section[%i] $= "Unpackaged Add-Ons" || %section[%i] $= "Content-Only Add-Ons")
         continue;
      
      %collapse = 0;
      if($RTB::CModManager::SectionCollapsed[%section[%i]])
         %collapse = 1;
      
      RTBMM_ModsView_createSectionRow(%section[%i],%collapse);
   }
   
   if(%hasNonRTBAddOns)
   {
      %collapse = 0;
      if($RTB::CModManager::SectionCollapsed["Non-RTB Add-Ons"] $= "" || $RTB::CModManager::SectionCollapsed["Non-RTB Add-Ons"] $= 1)
            %collapse = 1;
      RTBMM_ModsView_createSectionRow("Non-RTB Add-Ons",%collapse);
   }
   
   if(%hasUnpackagedAddOns)
   {
      %collapse = 0;
      if($RTB::CModManager::SectionCollapsed["Unpackaged Add-Ons"] $= "" || $RTB::CModManager::SectionCollapsed["Unpackaged Add-Ons"] $= 1)
            %collapse = 1;
      RTBMM_ModsView_createSectionRow("Unpackaged Add-Ons",%collapse);
   }
   
   if(%hasRTB2AddOns)
   {
      %collapse = 0;
      if($RTB::CModManager::SectionCollapsed["RTB2 Add-Ons"] $= "" || $RTB::CModManager::SectionCollapsed["RTB2 Add-Ons"] $= 1)
            %collapse = 1;
      RTBMM_ModsView_createSectionRow("RTB2 Add-Ons",%collapse);
   }
   
   if(%hasContentOnlyAddOns)
   {
      %collapse = 0;
      if($RTB::CModManager::SectionCollapsed["Content-Only Add-Ons"] $= "" || $RTB::CModManager::SectionCollapsed["Content-Only Add-Ons"] $= 1)
            %collapse = 1;
      RTBMM_ModsView_createSectionRow("Content-Only Add-Ons",%collapse);
   }
}

//- RTBMM_ModsView_createSectionRow (creates a section row)
function RTBMM_ModsView_createSectionRow(%name,%hide)
{
   %files = 0;
   for(%i=0;%i<RTBMM_FileCache.getCount();%i++)
   {
      if(RTBMM_FileCache.getObject(%i).file_type $= %name)
      {
         %file[%files] = RTBMM_FileCache.getObject(%i);
         %files++;
      }
   }
   
   if(%files <= 0)
      return;
   
   %container = new GuiSwatchCtrl()
   {
      position = 0 SPC $RTB::CModManager::GUI::CurrentY;
      extent = "680 28";
      color = "255 255 255 255";
   };
   RTBMM_GUI_PushControl(%container);
   
   %container.sec_id = $RTB::CModManager::Cache::NumSections;
   $RTB::CModManager::Cache::Section[$RTB::CModManager::Cache::NumSections] = %container;
   $RTB::CModManager::Cache::NumSections++;
   
   %s = (%files $= 1)?"":"s";
   %header = RTBMM_GUI_createHeader(1,"<just:left>        "@%name@"  <font:Arial:12>"@%files[%section[%i]]@" Add-On"@%s);
   %container.header = %header;
   %container.name = %name;
   %container.files = %files[%section[%i]];
   %bitmap = new GuiBitmapCtrl()
   {
      position = "5 6";
      extent = "16 16";
      bitmap = $RTB::Path@"images/icons/arrowDown";
   };
   %header.add(%bitmap);
   %container.add(%header);
   %header.position = "0 0";
   %container.bitmap = %bitmap;
   
   %mouseEvent = new GuiMouseEventCtrl()
   {
      extent = "680 28";
      
      eventType = "sectionClick";
      eventCallbacks = "0001000";
      
      id = $RTB::CModManager::Cache::NumSections-1;
      type = 1;
      
      container = %container;
   };
   %container.add(%mouseEvent);
   %container.mouseEvent = %mouseEvent;

   %sortString = "";      
   for(%i=0;%i<%files;%i++)
   {
      %sortString = %sortString@%file[%i]@"=>"@%file[%i].file_title@",";
   }
   %sortString = getSubStr(%sortString,0,strLen(%sortString)-1);
   %sortString = strReplace(sortFields(%sortString),",","\t");
   for(%j=0;%j<getFieldCount(%sortString);%j++)
   {
      %field = strReplace(getField(%sortString,%j),"=>","\t");
      %row = RTBMM_ModsView_createModRow(getField(%field,0));
      if(!isObject(%row))
         continue;
      %container.add(%row);
      %container.bringToFront(%row);
      
      %row.vertSizing = "top";
      %row.position = 0 SPC getWord(%container.extent,1);
      %container.extent = vectorAdd(%container.extent,"0" SPC getWord(%row.extent,1));
   }
   %container.originalHeight = getWord(%container.extent,1);
   
   if(%hide)
   {
      %mouseEvent.type = 2;
      RTBMM_ModsView_collapseSection($RTB::CModManager::Cache::NumSections-1,1);
   }
}

//- Event_sectionClick::onMouseUp (callback for clicking on a section header)
function Event_sectionClick::onMouseUp(%this)
{
   if(%this.type $= 1)
   {
      if(RTBMM_ModsView_collapseSection(%this.id))
      {
         %this.type = 2;
         %secName = $RTB::CModManager::Cache::Section[%this.id].name;
         $RTB::CModManager::SectionCollapsed[%secName] = 1;
      }
   }
   else if(%this.type $= 2)
   {
      if(RTBMM_ModsView_expandSection(%this.id))
      {
         %this.type = 1;
         %secName = $RTB::CModManager::Cache::Section[%this.id].name;
         $RTB::CModManager::SectionCollapsed[%secName] = 0;
      }
   }
}

//- RTBMM_ModsView_createModRow (creates a mod row for the section view)
function RTBMM_ModsView_createModRow(%cache)
{
   if(!isObject(%cache))
      return;
      
   %content = RTBMM_GUI_createContent(1,40,6,38,6,50);
   %c_icon = %content.getObject(0);
   %c_info = %content.getObject(1);
   %c_state = %content.getObject(2);
   %c_opts = %content.getObject(3);
   %content.setName("ModsViewRow_"@%cache.file_var);
   %content.file_title = %cache.file_title;   
   
   %icon = new GuiBitmapCtrl()
   {
      extent = "16 16";
      bitmap = $RTB::Path@"images/icons/"@%cache.file_icon;
   };
   %c_icon.add(%icon);
   RTBMM_GUI_Center(%icon);
   
   %title_text = new GuiMLTextCtrl()
   {
      position = "2 4";
      extent = "307 18";
      text = "<font:Arial Bold:14><color:777777> "@%cache.file_title;
   };
   %c_info.add(%title_text);
   
   %text = new GuiMLTextCtrl()
   {
      position = "4 20";
      extent = "450 18";
      text = "<font:Verdana:12><color:999999>by "@%cache.file_author;
   };
   %c_info.add(%text);
  
   if(%cache.file_platform $= "rtb" || %cache.file_platform $= "rtb2")
      %title_text.setText(%title_text.text@" <color:999999><font:Arial:12>v"@%cache.file_version);  
   
   %enabled = $AddOn__[%cache.file_var];
   if(%cache.file_isContent)
   {
      %swatch = new GuiSwatchCtrl()
      {
         position = %c_state.position;
         extent = %c_state.extent;
         color = "150 150 150 50";
      };
      %c_state.getGroup().add(%swatch);
      
      %icon = new GuiBitmapCtrl()
      {
         extent = "16 16";
         bitmap = $RTB::Path@"images/icons/tickGray";
         swatch = %swatch;
      };
      %c_state.add(%icon);
   }
   else if(%enabled $= 1 || %cache.file_special !$= "")
   {
      %swatch = new GuiSwatchCtrl()
      {
         position = %c_state.position;
         extent = %c_state.extent;
         color = "0 255 0 50";
      };
      %c_state.getGroup().add(%swatch);
      
      %icon = new GuiBitmapCtrl()
      {
         extent = "16 16";
         bitmap = $RTB::Path@"images/icons/tick";
         swatch = %swatch;
      };
      %c_state.add(%icon);
   }
   else
   {
      %swatch = new GuiSwatchCtrl()
      {
         position = %c_state.position;
         extent = %c_state.extent;
         color = "255 0 0 50";
      };
      %c_state.getGroup().add(%swatch);
      
      %icon = new GuiBitmapCtrl()
      {
         extent = "16 16";
         bitmap = $RTB::Path@"images/icons/cross";
         swatch = %swatch;
      };
      %c_state.add(%icon);
   }
   RTBMM_GUI_Center(%icon);
   
   if(%cache.file_isContent)
   {
      %btnLeft = new GuiBitmapButtonCtrl()
      {
         position = "7 6";
         extent = "82 25";
         text = " ";
         command = "RTBMM_TransferView_Add(\""@%cache.file_id@"\");";
         bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/downloadContent";
      };
      %c_opts.add(%btnLeft);
   }
   else if(%cache.file_special $= "clientside")
   {
      %btnLeft = new GuiBitmapCtrl()
      {
         position = "7 6";
         extent = "82 25";
         text = " ";
         bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/client_i";
      };
      %c_opts.add(%btnLeft);
   }
   else if(%cache.file_special $= "map")
   {
      %btnLeft = new GuiBitmapCtrl()
      {
         position = "7 6";
         extent = "82 25";
         text = " ";
         bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/map_i";
      };
      %c_opts.add(%btnLeft);
   }
   else if(%cache.file_special $= "decal")
   {
      %btnLeft = new GuiBitmapCtrl()
      {
         position = "7 6";
         extent = "82 25";
         text = " ";
         bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/decal_i";
      };
      %c_opts.add(%btnLeft);
   }
   else if(%cache.file_special $= "colorset")
   {
      %btnLeft = new GuiBitmapCtrl()
      {
         position = "7 6";
         extent = "82 25";
         text = " ";
         bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/colorset_i";
      };
      %c_opts.add(%btnLeft);
   }
   else
   {
      if(%enabled $= 1)
      {
         %btnLeft = new GuiBitmapButtonCtrl()
         {
            position = "7 6";
            extent = "82 25";
            text = " ";
            command = "RTBMM_ModsView_DisableAddon(\""@%cache.file_var@"\");";
            bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/disable";
         };
         %c_opts.add(%btnLeft);
      }
      else
      {
         %btnLeft = new GuiBitmapButtonCtrl()
         {
            position = "7 6";
            extent = "82 25";
            text = " ";
            command = "RTBMM_ModsView_EnableAddon(\""@%cache.file_var@"\");";
            bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/enable";
         };
         %c_opts.add(%btnLeft);
      }
   }
   
  %btnBug = new GuiBitmapCtrl()
  {
	 position = "87 6";
	 extent = "82 25";
	 text = " ";
	 bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/sendBug_i";
  };
  %c_opts.add(%btnBug);

  %btnUpdate = new GuiBitmapCtrl()
  {
	 position = "167 6";
	 extent = "82 25";
	 text = " ";
	 bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/update_i";
  };
  %c_opts.add(%btnUpdate);
   
   if(!%cache.file_default)
   {
      %btnDelete = new GuiBitmapButtonCtrl()
      {
         position = "247 6";
         extent = "82 25";
         text = " ";
         command = "RTBMM_GUI_createMessageBoxOKCancel(\"Are you sure?\",\"<just:center>Are you sure you want to permanently delete the selected add-on?\",\"RTBMM_ModsView_deleteAddon("@%cache@","@%content@");\");";
         bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/delete";
      };
      %c_opts.add(%btnDelete);
   }
   else
   {
      %btnDelete = new GuiBitmapCtrl()
      {
         position = "247 6";
         extent = "82 25";
         text = " ";
         bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/delete_i";
      };
      %c_opts.add(%btnDelete);
   }
   %cache.physical_row = %content;
   
   return %content;
}

//- RTBMM_ModsView_insertModRow (inserts a mod row live into the mods view)
function RTBMM_ModsView_insertModRow(%cache)
{
   for(%i=0;%i<$RTB::CModManager::Cache::NumSections-1;%i++)
   {
      %sec = $RTB::CModManager::Cache::Section[%i];
      if(%sec.name $= %cache.file_type)
      {
         %targetSection = %sec;
         break;
      }
   }
   
   if(!isObject(%targetSection))
   {
      RTBMM_Zones_Refresh();
      return;
   }
   else
   {
      %targetSection.files++;
      %s = (%targetSection.files == 1) ? "" : "s";
      %targetSection.header.getObject(1).setText("<color:888888><font:Arial Bold:15><just:left>        "@%targetSection.name@"  <font:Arial:12>"@%targetSection.files@" Add-On"@%s);
      
      %content = RTBMM_ModsView_createModRow(%cache,1);
      RTBMM_GUI_Offset(-(getWord(%content.extent,1)));
      
      for(%i=0;%i<%targetSection.getCount();%i++)
      {
         %row = %targetSection.getObject(0);
         if(!%targetSection.isMember(%content))
         {
            if(alphaCompare(%cache.file_title,%row.file_title) $= 2)
            {
               %row.position = vectorSub(%row.position,0 SPC getWord(%content.extent,1));
               %targetSection.add(%content);
               %targetSection.pushToBack(%content);
               %content.vertSizing = "top";
               %content.position = vectorAdd(%row.position,0 SPC getWord(%content.extent,1));
               %i++;
            }
            else if(%i $= %targetSection.getCount()-2)
            {
               %targetSection.add(%content);
               %targetSection.pushToBack(%content);
               %content.vertSizing = "top";
               %content.position = vectorSub("0 28",0 SPC getWord(%content.extent,1));
               %i++;
            }
         }
         else if(%row.file_title !$= "")
         {          
            %row.position = vectorSub(%row.position,0 SPC getWord(%content.extent,1));
         }
         %targetSection.pushToBack(%row);
      }
      %targetSection.originalHeight = vectorAdd(%targetSection.originalHeight,getWord(%content.extent,1));
      %sec_id = %targetSection.sec_id;
      
      if(%targetSection.mouseEvent.type $= 1)
      {
         %targetSection.resize(getWord(%targetSection.position,0),getWord(%targetSection.position,1),getWord(%targetSection.extent,0),getWord(%targetSection.extent,1)+getWord(%content.extent,1));
         for(%i=0;%i<$RTB::CModManager::Cache::NumSections;%i++)
         {
            %sec = $RTB::CModManager::Cache::Section[%i];
            if(%i > %sec_id)
               %sec.position = vectorAdd(%sec.position,0 SPC getWord(%content.extent,1));         
         }
      }
   }
}

//- RTBMM_ModsView_collapseAll (collapses all the sections)
function RTBMM_ModsView_collapseAll()
{
   for(%i=0;%i<$RTB::CModManager::Cache::NumSections;%i++)
   {
      if(RTBMM_ModsView_collapseSection(%i,1))
      {
         %sec = $RTB::CModManager::Cache::Section[%i];
         %sec.mouseEvent.type = 2;
         $RTB::CModManager::SectionCollapsed[%sec.name] = 1;
      }
   }
}

//- RTBMM_ModsView_collapseSection (collapses a mod view section)
function RTBMM_ModsView_collapseSection(%id,%noAnimate)
{
   %sec = $RTB::CModManager::Cache::Section[%id];
   if(%sec.sec_id $= "")
      return;
      
   if(!RTBCO_getPref("MM::Animate") || %noAnimate)
   {
      %sec.bitmap.position = "4 5";
      %sec.bitmap.setBitmap($RTB::Path@"images/icons/arrowRight");
      RTBMM_ModsView_instantCollapseSection(%id);
      return 1;
   }

   if(!isEventPending(%sec.expColSch))
   {
      %sec.bitmap.position = "4 5";
      %sec.bitmap.setBitmap($RTB::Path@"images/icons/arrowRight");
      if(%sec.files > 3)
         %time = 400;
      else
         %time = 100*%sec.files;
         
      if(%sec.files <= 0)
         %time = 100;
         
      RTBMM_ModsView_doCollapse(%id,0,getWord(%sec.extent,1),(28-getWord(%sec.extent,1))-1,%time);
      return 1;
   }
   return 0;
}

//- RTBMM_ModsView_doCollapse (looping function to animate the section collapsing)
function RTBMM_ModsView_doCollapse(%id,%time,%begin,%change,%duration)
{
   if(%time $= %duration)
      return;

   %sec = $RTB::CModManager::Cache::Section[%id];
   if(!isObject(%sec))
      return;
      
   %oldExtent = getWord(%sec.extent,1);
   %newExtent = mceil(Anim_EaseInOut(%time,%begin,%change,%duration));
   %sec.resize(getWord(%sec.position,0),getWord(%sec.position,1),getWord(%sec.extent,0),%newExtent);
   %sec.expColSch = schedule(10,0,"RTBMM_ModsView_doCollapse",%id,%time+10,%begin,%change,%duration);
   
   for(%i=%id+1;%i<$RTB::CModManager::Cache::NumSections;%i++)
   {
      %sec = $RTB::CModManager::Cache::Section[%i];
      %sec.position = vectorAdd(%sec.position,"0" SPC %newExtent-%oldExtent);
   }
   RTBMM_GUI_AutoResize();
}

//- RTBMM_ModsView_instantCollapseSection (Instantly collapses a section)
function RTBMM_ModsView_instantCollapseSection(%id)
{
   %sec = $RTB::CModManager::Cache::Section[%id];
   if(!isObject(%sec))
      return;

   %oldExtent = getWord(%sec.extent,1);
   %sec.resize(getWord(%sec.position,0),getWord(%sec.position,1),680,28);

   for(%i=%id+1;%i<$RTB::CModManager::Cache::NumSections;%i++)
   {
      %sec = $RTB::CModManager::Cache::Section[%i];
      %sec.position = vectorAdd(%sec.position,"0" SPC 28-%oldExtent);
   }
   RTBMM_GUI_AutoResize();
}

//- RTBMM_ModsView_expandAll (expands all the sections)
function RTBMM_ModsView_expandAll()
{
   for(%i=0;%i<$RTB::CModManager::Cache::NumSections;%i++)
   {
      if(RTBMM_ModsView_expandSection(%i,1))
      {
         %sec = $RTB::CModManager::Cache::Section[%i];
         %sec.mouseEvent.type = 1;
         $RTB::CModManager::SectionCollapsed[%sec.name] = 0;
      }
   }
}

//- RTBMM_ModsView_expandSection (Expands a section)
function RTBMM_ModsView_expandSection(%id,%noAnimate)
{
   %sec = $RTB::CModManager::Cache::Section[%id];
   if(%sec.sec_id $= "")
      return;
      
   if(!RTBCO_getPref("MM::Animate") || %noAnimate)
   {
      %sec.bitmap.position = "5 6";
      %sec.bitmap.setBitmap($RTB::Path@"images/icons/arrowDown");
      RTBMM_ModsView_instantExpandSection(%id);
      return 1;
   }
   
   if(!isEventPending(%sec.expColSch))
   {
      %sec.bitmap.position = "5 6";
      %sec.bitmap.setBitmap($RTB::Path@"images/icons/arrowDown");
      if(%sec.files > 3)
         %time = 400;
      else
         %time = 100*%sec.files;
         
      if(%sec.files <= 0)
         %time = 100;
         
      RTBMM_ModsView_doExpand(%id,0,getWord(%sec.extent,1),%sec.originalHeight-28,%time);
      return 1;
   }
   return 0;
}

//- RTBMM_ModsView_doExpand (looping function to animate the section expanding)
function RTBMM_ModsView_doExpand(%id,%time,%begin,%change,%duration)
{
   if(%time $= %duration)
      return;

   %sec = $RTB::CModManager::Cache::Section[%id];
   if(!isObject(%sec))
      return;
      
   %oldExtent = getWord(%sec.extent,1);
   %newExtent = mceil(Anim_EaseInOut(%time,%begin,%change,%duration));
   %sec.resize(getWord(%sec.position,0),getWord(%sec.position,1),getWord(%sec.extent,0),%newExtent);
   %sec.expColSch = schedule(10,0,"RTBMM_ModsView_doExpand",%id,%time+10,%begin,%change,%duration);
   
   for(%i=%id+1;%i<$RTB::CModManager::Cache::NumSections;%i++)
   {
      %sec = $RTB::CModManager::Cache::Section[%i];
      %sec.position = vectorAdd(%sec.position,"0" SPC %newExtent-%oldExtent);
   }
   RTBMM_GUI_AutoResize();
}

//- RTBMM_ModsView_instantExpandSection (Instantly expands a section)
function RTBMM_ModsView_instantExpandSection(%id)
{
   %sec = $RTB::CModManager::Cache::Section[%id];
   if(!isObject(%sec))
      return;

   %oldExtent = getWord(%sec.extent,1);
   %sec.resize(getWord(%sec.position,0),getWord(%sec.position,1),680,%sec.originalHeight);
   %newExtent = getWord(%sec.extent,1);

   for(%i=%id+1;%i<$RTB::CModManager::Cache::NumSections;%i++)
   {
      %sec = $RTB::CModManager::Cache::Section[%i];
      %sec.position = vectorAdd(%sec.position,"0" SPC %newExtent-%oldExtent);
   }
   RTBMM_GUI_AutoResize();
}

//- RTBMM_ModsView_EnableAll (enables all add-ons)
function RTBMM_ModsView_EnableAll()
{
   for(%i=0;%i<RTBMM_FileCache.getCount();%i++)
   {
      %file = RTBMM_FileCache.getObject(%i);
      
      if(%file.file_special $= "colorset" || %file.file_special $= "decal" || %file.file_special $= "map" || %file.file_special $= "clientside")
         continue;
         
      $AddOn__[%file.file_var] = 1;
   }
   export("$AddOn__*","config/server/ADD_ON_LIST.cs");
   
   RTBMM_ModsView_Init();
}

//- RTBMM_ModsView_DisableAll (disables all add-ons)
function RTBMM_ModsView_DisableAll()
{
   for(%i=0;%i<RTBMM_FileCache.getCount();%i++)
   {
      %file = RTBMM_FileCache.getObject(%i);
      
      if(%file.file_special $= "colorset" || %file.file_special $= "decal" || %file.file_special $= "map" || %file.file_special $= "clientside")
         continue;
         
      $AddOn__[%file.file_var] = 0;
   }
   export("$AddOn__*","config/server/ADD_ON_LIST.cs");
   
   RTBMM_ModsView_Init();
}

//- RTBMM_ModsView_EnableAddon (Sets an add-on to enabled and updates gui)
function RTBMM_ModsView_EnableAddon(%var)
{
   $AddOn__[%var] = 1;
   export("$AddOn__*","config/server/ADD_ON_LIST.cs");
   
   %container = "ModsViewRow_"@%var;
   %c_state = %container.getObject(2);
   %c_opts = %container.getObject(3);
   
   %c_state.getObject(0).setBitmap($RTB::Path@"images/icons/tick");
   %c_state.getObject(0).swatch.color = "0 255 0 50";
   
   %c_opts.getObject(0).setBitmap($RTB::Path@"images/ui/buttons/modManager/interface/disable");
   %c_opts.getObject(0).command = "RTBMM_ModsView_DisableAddon(\""@%var@"\");";
}

//- RTBMM_ModsView_DisableAddon (Sets an add-on to disabled and updates gui)
function RTBMM_ModsView_DisableAddon(%var)
{
   $AddOn__[%var] = 0;
   export("$AddOn__*","config/server/ADD_ON_LIST.cs");
   
   %container = "ModsViewRow_"@%var;
   %c_state = %container.getObject(2);
   %c_opts = %container.getObject(3);

   %c_state.getObject(0).setBitmap($RTB::Path@"images/icons/cross");
   %c_state.getObject(0).swatch.color = "255 0 0 50";
   
   %c_opts.getObject(0).setBitmap($RTB::Path@"images/ui/buttons/modManager/interface/enable");
   %c_opts.getObject(0).command = "RTBMM_ModsView_EnableAddon(\""@%var@"\");";
}

//- RTBMM_ModsView_resetDesc (Resets control value)
function RTBMM_ModsView_resetDesc(%ctrl)
{
   if(!isObject(%ctrl))
      return;
      
   %ctrl.setValue(%ctrl.oldValue);
}

//- RTBMM_ModsView_deleteAddon (Action to remove a row and alter the gui)
function RTBMM_ModsView_deleteAddon(%cache,%row,%noDel)
{
   %section = %row.getGroup();
   %id = %section.sec_id;
   %extent = getWord(%row.extent,1);
   %pos = getWord(%row.position,1);
   %row.delete();
   
   %section.files--;
   %s = (%section.files == 1) ? "" : "s";
   %section.header.getObject(1).setText("<color:888888><font:Arial Bold:15><just:left>        "@%section.name@"  <font:Arial:12>"@%section.files@" Add-On"@%s);

   if(%section.getCount() <= 2)
   {
      %extent = getWord(%section.extent,1);
      %section.delete();

      for(%i=%id+1;%i<$RTB::CModManager::Cache::NumSections;%i++)
      {
         %sec = $RTB::CModManager::Cache::Section[%i];
         %sec.position = vectorSub(%sec.position,"0" SPC %extent);
      }
   }
   else
   {
      for(%i=0;%i<%section.getCount()-1;%i++)
      {
         %row = %section.getObject(%i);
         if(getWord(%row.position,1) > %pos)
            %row.position = vectorSub(%row.position,0 SPC %extent);
      }
      
      %section.extent = vectorSub(%section.extent,0 SPC %extent);
      %section.originalHeight -= %extent;

      for(%i=%id+1;%i<$RTB::CModManager::Cache::NumSections;%i++)
      {
         %sec = $RTB::CModManager::Cache::Section[%i];
         %sec.position = vectorSub(%sec.position,"0" SPC %extent);
      }
      
      for(%i=0;%i<%section.getCount()-1;%i++)
      {
         %row = %section.getObject(%i);
         if(%row.getClassName() $= "GuiMouseEventCtrl")
         {
            %section.pushToBack(%row);
            continue;
         }
      }
   }
   RTBMM_GUI_AutoResize();

   if(!%noDel)
   {
      %filepath = %cache.file_path;
      fileDelete(%filepath);
      %cache.delete();
      
      for(%i=0;%i<RTBMM_GroupManager.getCount();%i++)
      {
         %group = RTBMM_GroupManager.getObject(%i);
         %group.removeItem(%cache);
      }
   }
}

//- RTBMM_ModsView_InitGroupsView (initates the groups view)
function RTBMM_ModsView_InitGroupsView()
{
   %header = $RTB::CModManager::Cache::SectionHeader;
   
   %header.getObject(1).setText("<color:FAFAFA><just:left><font:Impact:18>  Your Groups");
   
   %syncBtn = new GuiBitmapButtonCtrl()
   {
      position = "184 4";
      extent = "68 18";
      text = " ";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/create";
      command = "RTBMM_ModsView_createGroupAsk();";
   };
   %header.add(%syncBtn);   
   
   $RTB::CModManager::Cache::NumSections = 0;   
   
   if(RTBMM_GroupManager.getCount() <= 0)
   {
      RTBMM_GUI_createMessage("<br><br>You do not have any Add-On Groups.<br><br>");
      return;
   }
   else
   {
      %sortString = "";
      for(%i=0;%i<RTBMM_GroupManager.getCount();%i++)
      {
         %group = RTBMM_GroupManager.getObject(%i);
         %sortString = %sortString@%group.getID()@"=>"@%group.name@",";
      }
      %sortString = getSubStr(%sortString,0,strLen(%sortString)-1);
      %sortString = strReplace(sortFields(%sortString),",","\t");
      
      for(%i=0;%i<getFieldCount(%sortString);%i++)
      {
         %sort = strReplace(getField(%sortString,%i),"=>","\t");
         %id = getField(%sort,0);
         %name = getField(%sort,1);
         
         if($RTB::CModManager::SectionCollapsed["G_"@%name])
            RTBMM_ModsView_createGroupRow(%id,1);
         else
            RTBMM_ModsView_createGroupRow(%id,0);
      }
   }
}

function RTBMM_ModsView_createGroupRow(%group,%hide)
{
   %container = new GuiSwatchCtrl()
   {
      position = 0 SPC $RTB::CModManager::GUI::CurrentY;
      extent = "680 28";
      color = "255 255 255 255";
   };
   RTBMM_GUI_PushControl(%container);
   
   %container.sec_id = $RTB::CModManager::Cache::NumSections;
   $RTB::CModManager::Cache::Section[$RTB::CModManager::Cache::NumSections] = %container;
   $RTB::CModManager::Cache::NumSections++;
   
   %s = (%group.items $= 1)?"":"s";
   %header = RTBMM_GUI_createHeader(1,"<just:left>        "@%group.name@"  <font:Arial:12>"@%group.items@" Add-On"@%s);
   
   %container.header = %header;
   %container.name = "G_"@%group.name;
   %container.files = %group.items;
   %bitmap = new GuiBitmapCtrl()
   {
      position = "5 6";
      extent = "16 16";
      bitmap = $RTB::Path@"images/icons/arrowDown";
   };
   %header.add(%bitmap);
   %container.add(%header);
   %header.position = "0 0";
   %container.bitmap = %bitmap;
   
   %mouseEvent = new GuiMouseEventCtrl()
   {
      extent = "610 28";
      
      eventType = "sectionClick";
      eventCallbacks = "0001000";
      
      id = $RTB::CModManager::Cache::NumSections-1;
      type = 1;
      
      container = %container;
   };
   %container.add(%mouseEvent);
   %container.mouseEvent = %mouseEvent;
   
   %add = new GuiBitmapButtonCtrl()
   {
      position = "620 5";
      extent = "16 16";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/add";
      text = " ";
      command = "RTBMM_ModsView_groupAddonSelect("@%group@");";
   };
   %header.add(%add);
   
   %remove = new GuiBitmapButtonCtrl()
   {
      position = "640 5";
      extent = "16 16";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/removeSmall";
      text = " ";
      command = "RTBMM_ModsView_removeGroup("@%group@");";
   };
   %header.add(%remove);

   %content = RTBMM_GUI_createContent(1,40,100);
   %container.add(%content);
   %container.bringToFront(%content);
   
   %content.vertSizing = "top";
   %content.position = 0 SPC getWord(%container.extent,1);
   RTBMM_ModsView_renderGroupContent(%content,%group);
   
   if(%hide)
   {
      %mouseEvent.type = 2;
      RTBMM_ModsView_collapseSection($RTB::CModManager::Cache::NumSections-1,1);
   }
}

//- RTBMM_ModsView_renderGroupContent (renders the mod rows in the content control)
function RTBMM_ModsView_renderGroupContent(%content,%group)
{
   if(%group.items <= 0)
   {
      %icon = new GuiBitmapCtrl()
      {
         position = "20" SPC ((%j*31)+15);
         extent = "16 16";
         bitmap = $RTB::Path@"images/icons/help";
      };
      %content.add(%icon);
      
      %text = new GuiMLTextCtrl()
      {
         position = "40" SPC ((%j*31)+17);
         extent = "400 10";
         text = "<font:Verdana:12><color:888888>It looks like you don't have any add-ons in this group!";
      };
      %content.add(%text);

      %content.resize(getWord(%content.position,0),getWord(%content.position,1),getWord(%content.extent,0),getWord(%icon.position,1)+31);
      %content.getGroup().extent = vectorAdd(%content.getGroup().extent,"0" SPC getWord(%content.extent,1));
      %content.getGroup().originalHeight = getWord(%content.getGroup().extent,1);
      RTBMM_GUI_AutoResize();
      return;
   }
   
   %sortString = "";
   for(%i=0;%i<%group.items;%i++)
   {
      %sortString = %sortString@%group.item[%i]@"=>"@%group.item[%i].file_title@",";
   }
   %sortString = getSubStr(%sortString,0,strLen(%sortString)-1);
   %sortString = strReplace(sortFields(%sortString),",","\t");
   
   for(%j=0;%j<getFieldCount(%sortString);%j++)
   {
      %field = strReplace(getField(%sortString,%j),"=>","\t");
      %id = getField(%field,0);

      if(%id.file_type $= "Unpackaged Add-Ons")
         %icon = $RTB::Path@"images/icons/help";
      else if(%id.file_platform $= "bl")
         %icon = $RTB::Path@"images/icons/blLogo";
      else
         %icon = $RTB::Path@"images/icons/rtbLogo";

      %icon = new GuiBitmapCtrl()
      {
         position = "20" SPC ((%j*31)+15);
         extent = "16 16";
         bitmap = %icon;
      };
      %content.add(%icon);
      
      %text = new GuiMLTextCtrl()
      {
         position = "40" SPC ((%j*31)+17);
         extent = "400 10";
         text = "<font:Verdana Bold:12><color:666666>"@%id.file_title@" <font:Verdana:12><color:888888>by "@%id.file_author;
      };
      %content.add(%text);
      
      %text = new GuiMLTextCtrl()
      {
         position = "350" SPC ((%j*31)+17);
         extent = "400 10";
         text = "<font:Verdana Bold:12><color:666666>"@%id.file_type;
      };
      %content.add(%text);
      
      %text = new GuiMLTextCtrl()
      {
         position = "460" SPC ((%j*31)+17);
         extent = "400 10";
         text = "<font:Verdana:12><color:666666>"@%id.file_zip;
      };
      %content.add(%text);
      
      %remove = new GuiBitmapButtonCtrl()
      {
         position = "640" SPC ((%j*31)+15);
         extent = "16 16";
         bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/removeSmall";
         text = " ";
         command = "RTBMM_ModsView_removeItem("@%group@","@%id@");";
      };
      %content.add(%remove);      
      
      if(%j > 0)
      {
         %divider = new GuiBitmapCtrl()
         {
            position = "15" SPC ((%j*31)+7);
            extent = "650 2";
            bitmap = $RTB::Path@"images/ui/cellDivider_light";
         };  
         %content.add(%divider);
      }
   }
   %content.resize(getWord(%content.position,0),getWord(%content.position,1),getWord(%content.extent,0),getWord(%icon.position,1)+31);
   %content.getGroup().extent = vectorAdd(%content.getGroup().extent,"0" SPC getWord(%content.extent,1));
   %content.getGroup().originalHeight = getWord(%content.getGroup().extent,1);
   RTBMM_GUI_AutoResize();
}

//- RTBMM_ModsView_createGroupAsk (creates a prompt to make a group)
function RTBMM_ModsView_createGroupAsk()
{
   %window = RTBMM_GUI_createWindow("Create a Group");
   %window.resize(0,0,275,110);
   RTBMM_GUI_Center(%window);
   
   %text = new GuiMLTextCtrl()
   {
      position = "5 5";
      extent = "300 10";
      text = "<font:Verdana:12><color:888888>Please enter a name for your new Group:";
   };
   %window.canvas.add(%text);
   
   %edit = new GuiTextEditCtrl()
   {
      profile = RTB_TextEditProfile;
      position = "6 21";
      extent = "256 16";
      accelerator = "enter";
      altCommand = "RTBMM_ModsView_createGroup($thisControl.getValue());RTBMM_GUI_closeWindow("@%window@");";
   };
   %window.canvas.add(%edit);

   %button = new GuiBitmapButtonCtrl()
   {
      position = "205 43";
      extent = "58 25";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/ok";
      text = " ";
      command = "RTBMM_ModsView_createGroup("@%edit@".getValue());RTBMM_GUI_closeWindow("@%window@");";
   };
   %window.canvas.add(%button);
}

//- RTBMM_ModsView_createGroup (creates a new group)
function RTBMM_ModsView_createGroup(%name,%skip)
{
   if(%name $= "")
   {
      if(!%skip)
      {
         RTBMM_GUI_createMessageBoxOK("Ooops","You have not entered a name for your new group.");
         RTBMM_ModsView_createGroupAsk();
      }
      return;
   }
   
   if(%group = RTBMM_GroupManager.addGroup(%name))
   {
      if(!%skip)
         RTBMM_ModsView_groupAddonSelect(%group,1);
      return %group;
   }
   else
   {
      if(!%skip)
         RTBMM_GUI_createMessageBoxOK("Oh No!","You've already got a group called "@%name@".");
      return 0;
   }
}

//- RTBMM_ModsView_groupAddonSelect (allows selection of included add-ons)
function RTBMM_ModsView_groupAddonSelect(%group,%closeDelete)
{
   %window = RTBMM_GUI_createWindow("Add-On Selector");
   %window.resize(0,0,315,500);
   RTBMM_GUI_Center(%window);
   
   if(%closeDelete)
   {
      %window.closeButton.command = %window.closeButton.command@%group@".delete();RTBMM_GroupManager.saveDat();";
   }
  
   %text = new GuiMLTextCtrl()
   {
      position = "8 8";
      extent = "280 1";
      text = "<color:666666><font:Arial:13>Browse the list and tick/untick the add-ons you want to be in this group. You can have as many as you want.";
   };
   %window.canvas.add(%text);
   
   %parent = new GuiSwatchCtrl()
   {
      position = "7 40";
      extent = "277 380";
      color = "200 200 200 255";
      
      new GuiSwatchCtrl()
      {
         position = "1 1";
         extent = "275 378";
         color = "245 245 245 255";
      };
   };
   %window.canvas.add(%parent);
   
   %scroll = new GuiScrollCtrl()
   {
      profile = RTB_ScrollProfile;
      position = "7 40";
      extent = "292 379";
      hScrollBar = "AlwaysOff";
      
      new GuiSwatchCtrl(RTBMM_GroupSelect_Window)
      {
         position = "1 1";
         extent = "558 298";
         color = "0 0 0 0";
         
         new GuiSwatchCtrl()
         {
            position = "1 1";
            extent = "558 30";
            color = "0 0 0 0";
            
            new GuiSwatchCtrl()
            {
               position = "0 0";
               extent = "242 30";
               color = "215 215 215 255";
               
               new GuiMLTextCtrl()
               {
                  position = "35 8";
                  extent = "172 14";
                  text = "<just:center><color:888888><font:Arial Bold:14>Add-On";
               };
            };
            
            new GuiSwatchCtrl()
            {
               position = "243 0";
               extent = "30 30";
               color = "215 215 215 255";
            };
         };
      };
   };
   %window.canvas.add(%scroll);
   
   %allBtn = new GuiBitmapButtonCtrl()
   {
      position = "10 432";
      extent = "21 18";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/all";
      command = "RTBMM_ModsView_selectAll("@%window@");";
      text = " ";
   };
   %window.canvas.add(%allBtn);
   
   %enabledBtn = new GuiBitmapButtonCtrl()
   {
      position = "32 435";
      extent = "50 15";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/enabled";
      command = "RTBMM_ModsView_selectEnabled("@%window@");";
      text = " ";
   };
   %window.canvas.add(%enabledBtn);  
   
   %enabledBtn = new GuiBitmapButtonCtrl()
   {
      position = "83 435";
      extent = "34 15";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/none";
      command = "RTBMM_ModsView_selectNone("@%window@");";
      text = " ";
   };
   %window.canvas.add(%enabledBtn);  
   
   %okBtn = new GuiBitmapButtonCtrl()
   {
      position = "225 430";
      extent = "58 25";
      bitmap = $RTB::Path@"images/ui/buttons/modManager/interface/ok";
      command = "RTBMM_ModsView_saveAddOnSelection("@%window@","@%group@");";
      text = " ";
   };
   %window.canvas.add(%okBtn);
   
   %numCats = 0;
   $RTB::CModManager::GroupSelect::CBoxes = 0;
   for(%i=0;%i<RTBMM_FileCache.getCount();%i++)
   {
      %cache = RTBMM_FileCache.getObject(%i);
      if(%cache.file_special !$= "")
         continue;
         
      %sorter[%cache.file_type] = %sorter[%cache.file_type]@%cache@"=>"@%cache.file_title@",";
       
      if(!%added[%cache.file_type])
      {
         %cat[%numCats] = %cache.file_type;
         %numCats++;
         
         %added[%cache.file_type] = 1;
      }
   }
   
   for(%i=0;%i<%numCats;%i++)
   {
      %catSorter = %catSorter@%i@"=>"@%cat[%i]@",";
   }
   %catSorter = getSubStr(%catSorter,0,strLen(%catSorter)-1);
   %cats = strReplace(sortFields(%catSorter),",","\t");
   
   for(%i=0;%i<getFieldCount(%cats);%i++)
   {
      %cat = strReplace(getField(%cats,%i),"=>","\t");
      
      if(%sorter[getField(%cat,1)] $= "")
         continue;      
      
      %rows = RTBMM_GroupSelect_Window.getCount()-1;
      %ySpace = (%rows*40) + (%rows+1) + 31;
      
      %container = new GuiSwatchCtrl()
      {
         position = "1" SPC %ySpace;
         extent = "275 40";
         color = "0 0 0 0";
      };
      RTBMM_GroupSelect_Window.add(%container);
      RTBMM_GroupSelect_Window.resize(1,1,558,%ySpace+40);
      
      %check = new GuiSwatchCtrl()
      {
         position = "0 0";
         extent = "273 40";
         color = "225 225 225 255";
         
         new GuiBitmapCtrl()
         {
            position = "8 12";
            extent = "16 16";
            bitmap = $RTB::Path@"images/icons/arrowRight";
         };
         
         new GuiMLTextCtrl()
         {
            position = "24 14";
            extent = "200 16";
            text = "<font:Arial Bold:14><color:888888> "@getField(%cat,1);
         };
         
         new GuiCheckboxCtrl()
         {
            profile = RTB_CheckBoxProfile;
            position = "251 13";
            extent = "16 16";
            text = " ";
            catBox = getField(%cat,1);
            command = "RTBMM_ModsView_clickGroupCat($thisControl);";
            numEnabled = 0;
            numItems = 0;
         };
      };
      %container.add(%check);
      %catCheck = %check.getObject(2);
      $RTB::CModManager::GroupSelect::CBox[$RTB::CModManager::GroupSelect::CBoxes] = %check.getObject(2);
      $RTB::CModManager::GroupSelect::CBoxes++;
      
      %sorter[getField(%cat,1)] = getSubStr(%sorter[getField(%cat,1)],0,strLen(%sorter[getField(%cat,1)])-1);
      %mods = strReplace(sortFields(%sorter[getField(%cat,1)]),",","\t");
      
      for(%j=0;%j<getFieldCount(%mods);%j++)
      {
         %mod = strReplace(getField(%mods,%j),"=>","\t");
         %cache = getField(%mod,0);
            
         %rows = RTBMM_GroupSelect_Window.getCount()-1;
         %ySpace = (%rows*40) + (%rows+1) + 31;
         
         %container = new GuiSwatchCtrl()
         {
            position = "1" SPC %ySpace;
            extent = "275 40";
            color = "0 0 0 0";
         };
         RTBMM_GroupSelect_Window.add(%container);
         RTBMM_GroupSelect_Window.resize(1,1,558,%ySpace+40);
         
         %icon = new GuiSwatchCtrl()
         {
            position = "0 0";
            extent = "40 40";
            color = "230 230 230 255";
            
            new GuiBitmapCtrl()
            {
               position = "12 12";
               extent = "16 16";
               bitmap = $RTB::Path@"images/icons/"@%cache.file_icon;
            };
         };
         %container.add(%icon);
         
         %info = new GuiSwatchCtrl()
         {
            position = "41 0";
            extent = "201 40";
            color = "230 230 230 255";
            
            new GuiMLTextCtrl()
            {
               position = "4 1";
               extent = "300 1";
               text = "<font:Arial Bold:14><color:777777>"@%cache.file_title;
            };
            
            new GuiMLTextCtrl()
            {
               position = "3 12";
               extent = "300 1";
               text = "<font:Arial:13><color:888888>by "@%cache.file_author;
            };
            
            new GuiMLTextCtrl()
            {
               position = "4 25";
               extent = "300 1";
               text = "<font:Arial:13><color:AAAAAA>"@%cache.file_zip;
            };
         };
         %container.add(%info);
         
         %check = new GuiSwatchCtrl()
         {
            position = "243 0";
            extent = "30 40";
            color = "230 230 230 255";
            
            new GuiCheckBoxCtrl()
            {
               profile = RTB_CheckBoxProfile;
               position = "8 12";
               extent = "16 16";
               text = " ";
               catCheck = %catCheck;
               command = "RTBMM_ModsView_clickGroupMod($thisControl);";
            };
         };
         %container.add(%check);

         if(%group.hasItem(%cache.file_zipname))
         {
            %check.getObject(0).setValue(1);
            %catCheck.numEnabled++;
         }
         %catCheck.numItems++;            
            
         %check.getObject(0).cache = %cache;
         $RTB::CModManager::GroupSelect::CBox[$RTB::CModManager::GroupSelect::CBoxes] = %check.getObject(0);
         $RTB::CModManager::GroupSelect::CBoxes++;
      }
      
      if(%catCheck.numEnabled >= %catCheck.numItems)
         %catCheck.setValue(1);
   }
}

//- RTBMM_ModsView_clickGroupCat (click for a category box of the selector)
function RTBMM_ModsView_clickGroupCat(%this)
{
   for(%i=0;%i<$RTB::CModManager::GroupSelect::CBoxes;%i++)
   {
      %cbox = $RTB::CModManager::GroupSelect::CBox[%i];
      if(%cbox.cache.file_type $= %this.catBox)
      {
         %cbox.setValue(%this.getValue());   
         %this.numEnabled++;
      }
   }
   
   if(%this.numEnabled > %this.numItems)
      %this.numEnabled = %this.numItems;
}

//- RTBMM_ModsView_clickGroupMod (click for a mod in a category of the selector)
function RTBMM_ModsView_clickGroupMod(%this)
{
   if(%this.getValue() $= 1)
      %this.catCheck.numEnabled++;
   else
      %this.catCheck.numEnabled--;
      
   if(%this.catCheck.numEnabled >= %this.catCheck.numItems)
   {
      %this.catCheck.numEnabled = %this.catCheck.numItems;
      %this.catCheck.setValue(1);
   }
   else
      %this.catCheck.setValue(0);
}

//- RTBMM_ModsView_selectAll (checks all boxes in the group add-on selector)
function RTBMM_ModsView_selectAll(%window)
{
   for(%i=0;%i<$RTB::CModManager::GroupSelect::CBoxes;%i++)
   {
      %cbox = $RTB::CModManager::GroupSelect::CBox[%i];
      %cbox.setValue(1);
      if(%cbox.numItems !$= "")
         %cbox.numEnabled = %cbox.numItems;
   }
}

//- RTBMM_ModsView_selectEnabled (checks all boxes that are currently enabled)
function RTBMM_ModsView_selectEnabled(%window)
{
   RTBMM_ModsView_selectNone();
   for(%i=0;%i<$RTB::CModManager::GroupSelect::CBoxes;%i++)
   {
      %cbox = $RTB::CModManager::GroupSelect::CBox[%i];
      if($AddOn__[%cbox.cache.file_var] $= 1)
      {
         %cbox.setValue(1);
         RTBMM_ModsView_clickGroupMod(%cbox);
      }
   }
}

//- RTBMM_ModsView_selectNone (unchecks all boxes in the group add-on selector)
function RTBMM_ModsView_selectNone(%window)
{
   for(%i=0;%i<$RTB::CModManager::GroupSelect::CBoxes;%i++)
   {
      %cbox = $RTB::CModManager::GroupSelect::CBox[%i];
      %cbox.setValue(0);
      if(%cbox.numItems !$= "")
         %cbox.numEnabled = 0;
   }
}

//- RTBMM_ModsView_saveAddOnSelection (saves the current selection of add-ons)
function RTBMM_ModsView_saveAddOnSelection(%window,%group)
{
   %group.items = 0;
   for(%i=0;%i<$RTB::CModManager::GroupSelect::CBoxes;%i++)
   {
      %cbox = $RTB::CModManager::GroupSelect::CBox[%i];
      if(%cbox.getValue() $= 1 && %cbox.cache !$= "")
      {
         %group.item[%group.items] = %cbox.cache;
         %group.items++;
      }
   }
   RTBMM_GroupManager.saveDat();
   RTBMM_GUI_closeWindow(%window);
   schedule(1,0,"RTBMM_ModsView_Init","groups");
}

//- RTBMM_ModsView_removeItem (removes an item from a group)
function RTBMM_ModsView_removeItem(%group,%id)
{
   %group.removeItem(%id);
   
   RTBMM_GroupManager.saveDat();
   schedule(1,0,"RTBMM_ModsView_Init","groups");
}

//- RTBMM_ModsView_removeGroup (removes a group)
function RTBMM_ModsView_removeGroup(%id,%conf)
{
   if(!%conf)
   {
      RTBMM_GUI_createMessageBoxOKCancel("Fo real?","Are you sure you want to delete this group:<br><br><lmargin:10>"@%id.name@" containing "@%id.items@" add-ons?","RTBMM_ModsView_removeGroup("@%id@",1);");
      return;
   }
   %id.delete();
   RTBMM_GroupManager.saveDat();
   schedule(1,0,"RTBMM_ModsView_Init","groups");
}

//#####################################################################################################
//
//     _____                              _   
//    / ____|                            | |  
//   | (___  _   _ _ __  _ __   ___  _ __| |_ 
//    \___ \| | | | '_ \| '_ \ / _ \| '__| __|
//    ____) | |_| | |_) | |_) | (_) | |  | |_ 
//   |_____/ \__,_| .__/| .__/ \___/|_|   \__|
//                | |   | |                   
//                |_|   |_|                   
//
//
//##################################################################################################### 

//*********************************************************
//* Group Class
//*********************************************************
if(!isObject(RTBMM_GroupManager))
{
   new ScriptGroup(RTBMM_GroupManager);
   RTBGroup.add(RTBMM_GroupManager);
}

//- RTBMM_GroupManager::load (loads the existing groups.dat file)
function RTBMM_GroupManager::loadDat(%this)
{
   %this.clear();
   %this.numGroups = 0;
   %this.loaded = 1;
   
   if(isFile("config/client/rtb/groups.dat"))
   {
      %fo = new FileObject();
      if(%fo.openForRead("config/client/rtb/groups.dat"))
      {
         while(!%fo.isEOF())
         {
            %number++;
            %line = %fo.readLine();
         
            if(%number%2)
            {
               %group = %this.addGroup(%line);
               
               if(!isObject(%group))
               {
                  %fo.readLine();
                  continue;
               }
            }
            else
            {
               if(!isObject(%group))
               {
                  %fo.delete();
                  echo("\c2ERROR: Parse error in groups.dat (RTBMM_GroupManager::load)");
                  return;
               }
               
               %line = strReplace(%line,",","\t");
               for(%i=0;%i<getFieldCount(%line);%i++)
               {
                  %group.addItem(getField(%line,%i));
               }
            }
         }
      }
      %fo.delete();
   }
}

//- RTBMM_GroupManager::save (saves the group manager)
function RTBMM_GroupManager::saveDat(%this)
{
   %fo = new FileObject();
   if(!%fo.openForWrite("config/client/rtb/groups.dat"))
   {
      echo("\c2ERROR: Unable to write to groups.dat (RTBMM_GroupManager::save)");
      %fo.delete();
      return;
   }
   
   for(%i=0;%i<%this.getCount();%i++)
   {
      %itemLine = "";
      %group = %this.getObject(%i);
      %fo.writeLine(%group.name);
      for(%j=0;%j<%group.items;%j++)
      {
         %itemLine = %itemLine@%group.item[%j].file_zipname@",";
      }
      if(%itemLine !$= "")
         %itemLine = getSubStr(%itemLine,0,strLen(%itemLine)-1);
      %fo.writeLine(%itemLine);
   }
   %fo.close();
   %fo.delete();
}

//- RTBMM_GroupManager::addGroup (creates a new group)
function RTBMM_GroupManager::addGroup(%this,%name)
{
   if(%this.hasGroup(%name))
      return 0;
      
   %group = new ScriptObject()
   {
      class = "RTB_Group";
      
      name = %name;
      items = 0;
   };
   %this.add(%group);
   
   return %group;
}

//- RTBMM_GroupManager::hasGroup (checks if a group exists)
function RTBMM_GroupManager::hasGroup(%this,%name)
{
   for(%i=0;%i<%this.getCount();%i++)
   {
      if(%this.getObject(%i).name $= %name)
         return 1;
   }
   return 0;
}

//- RTBMM_GroupManager::deleteGroup (deletes an existing group)
function RTBMM_GroupManager::deleteGroup(%this,%name)
{
   if(!%this.hasGroup(%name))
      return 0;
      
   for(%i=0;%i<%this.getCount();%i++)
   {
      if(%this.getObject(%i).name $= %name)
      {
         %this.getObject(%i).delete();
         %this.saveDat();
         return 1;
      }
   }
   return 0;
}

//- RTB_Group::addItem (adds an item to a group)
function RTB_Group::addItem(%this,%zip)
{
   if(%this.hasItem(%zip))
      return;
      
   if(RTBMM_FileCache.getByZip(%zip))
   {
      %this.item[%this.items] = RTBMM_FileCache.getByZip(%zip);
      %this.items++;
   }
}

//- RTB_Group::hasItem (checks if this group already has this item)
function RTB_Group::hasItem(%this,%zip)
{
   for(%i=0;%i<%this.items;%i++)
   {
      if(%this.item[%i].file_zipname $= %zip)
         return 1;
   }
   return 0;
}

//- RTB_Group::removeItem (removes an item from a group)
function RTB_Group::removeItem(%this,%id)
{
   if(!%this.hasItem(%id.file_zipname))
      return;

   %k = 0;
   for(%i=0;%i<%this.items;%i++)
   {
      if(%this.item[%i] $= %id)
         continue;
      %this.item[%k] = %this.item[%i];
      %k++;
   }
   %this.items--;
}

//*********************************************************
//* Add-Ons Cache (No more RM faggotry)
//*********************************************************
if(!isObject(RTBMM_FileCache))
{
   new ScriptGroup(RTBMM_FileCache)
   {
      class = "FileCache";
      
      refreshTime = 0;
   };
   RTBGroup.add(RTBMM_FileCache);
}

//- FileCache::refresh (Refreshes the list of files discovered by the FC)
function FileCache::refresh(%this)
{
   %this.clear();
   %this.refreshTime = getSimTime();
   
   for(%i=0;%i<RTB_FileCache.getCount();%i++)
   {
      %file = RTB_FileCache.getObject(%i);
      %this.addPath(%file.path);
   }
   %this.refreshed = 1;
}

//- FileCache::list (Lits all files in the cache)
function FileCache::list(%this)
{
   echo(%this.getCount());
   echo("-----------------------------------------------");
   for(%i=0;%i<%this.getCount();%i++)
   {
      echo(%this.getObject(%i).file_path SPC "\c2" @ %this.getObject(%i).file_zipname@"\c0 ("@%this.getObject(%i).file_type@")");
   }
   echo("");
}

//- FileCache::addPath (Adds a path to the file cache)
function FileCache::addPath(%this,%filepath)
{
   if(!RTB_FileCache.hasPath(%filepath))
      RTB_FileCache.addPath(%filepath);
      
   if(!RTB_FileCache.hasPath(%filepath))
      return false;
   
   %masterCache = RTB_FileCache.getByPath(%filepath);   
   
   if(%this.exists(%filepath))
   {
      %oldCacheId = %this.getByPath(%filepath);
      %this.removeFile(%filepath);
   }
   
   %file = new ScriptObject()
   {
      //standard props
      file_zip = %masterCache.zip;
      file_zipname = %masterCache.zipname;
      file_path = %masterCache.path;
      file_title = %masterCache.title;
      file_author = %masterCache.author;
      file_desc = %masterCache.description;
      file_size = %masterCache.filesize;
      file_var = %masterCache.variableName;
      
      //management props
      file_platform = %masterCache.platform;
      file_isContent = %masterCache.isContent;
      
      //public props
      file_type = %masterCache.type;         
      
      //rtb props
      file_id = %masterCache.id;
      file_icon = %masterCache.icon;
      file_version = %masterCache.version;
   };
   %this.add(%file);

   if(!isFile(%filepath))
   {
      %file.file_type = "Unpackaged Add-Ons";
      %file.file_icon = "help";
      %file.file_default = 1;
   }
   else if(%file.file_isContent)
   {
      %file.file_type = "Content-Only Add-Ons";
      %file.file_icon = "package_green";
   }
   else if(!%file.file_id)
   {
      for(%i=0;%i<$RTB::CModManager::DefaultBLMods;%i++)
      {
         %file.file_type = "Non-RTB Add-Ons";
         %mod = $RTB::CModManager::DefaultBLMod[%i];
         if(%mod $= fileBase(%filepath))
         {
            %file.file_default = 1;
            %file.file_type = "Default Add-Ons";
            break;
         }
      }
      %file.file_icon = "blLogo";
      %file.file_platform = "bl";
   }
      
   if(%file.file_platform $= "rtb2")
   {
     %file.file_icon = "link_break";
     %file.file_type = "RTB2 Add-Ons";
   }
      
   if(getSubStr(fileBase(%filepath),0,4) $= "Map_")
      %file.file_special = "map";
   else if(getSubStr(fileBase(%filepath),0,6) $= "Decal_" || getSubStr(fileBase(%filepath),0,5) $= "Face_")
      %file.file_special = "decal";
   else if(isFile("Add-Ons/"@fileBase(%filepath)@"/client.cs") && !isFile("Add-Ons/"@fileBase(%filepath)@"/server.cs"))
      %file.file_special = "clientside";
   else if(getSubStr(fileBase(%filepath),0,9) $= "Colorset_")
      %file.file_special = "colorset";
   else
      %file.file_special = "";
         
   if(!clientIsValidAddOn(fileBase(%filepath),1))
      return;
      
   if(%oldCacheId !$= "")
   {
      for(%i=0;%i<RTBMM_GroupManager.getCount();%i++)
      {
         %group = RTBMM_GroupManager.getObject(%i);
         for(%j=0;%j<%group.items;%j++)
         {
            if(%group.item[%j] $= %oldCacheId)
               %group.item[%j] = %file;
         }
      }
   }
   return %file;
}

//- FileCache::get (Returns the cache record for the file id)
function FileCache::get(%this,%id)
{
   for(%i=0;%i<%this.getCount();%i++)
   {
      if(%this.getObject(%i).file_id $= %id)
         return %this.getObject(%i);
   }
   return 0;
}

//- FileCache::getByPath (Returns the cache record for the filepath)
function FileCache::getByPath(%this,%path)
{
   for(%i=0;%i<%this.getCount();%i++)
   {
      if(%this.getObject(%i).file_path $= %path)
         return %this.getObject(%i);
   }
   return 0;
}

//- FileCache::getByZip (Returns the cache record for the zip)
function FileCache::getByZip(%this,%zip)
{
   for(%i=0;%i<%this.getCount();%i++)
   {
      if(%this.getObject(%i).file_zipname $= %zip)
         return %this.getObject(%i);
   }
   return 0;
}

//- FileCache::exists (Checks to see if the file cache knows about a file)
function FileCache::exists(%this,%filepath)
{
   for(%i=0;%i<%this.getCount();%i++)
   {
      if(%this.getObject(%i).file_path $= %filepath)
         return 1;
   }
   return 0;
}

//- FileCache::removeFile (Removes a file from the cache)
function FileCache::removeFile(%this,%filepath)
{
   for(%i=0;%i<%this.getCount();%i++)
   {
      if(%this.getObject(%i).file_path $= %filepath)
      {
         %this.getObject(%i).delete();
         return 1;
      }
   }
   return 0;
}

//*********************************************************
//* Load Cache
//*********************************************************
RTBMM_FileCache.refresh();

//*********************************************************
//* Mod Manager Support Functions
//*********************************************************
//- RTBMM_parseBBCode (Parses bbCode into TorqueML)
function RTBMM_parseBBCode(%message)
{
   %message = strReplace(%message,"<br>[*]","<br><bitmap:add-ons/system_returntoblockland/images/icons/bullet_list>");
   %message = strReplace(%message,"[*]","<br><bitmap:add-ons/system_returntoblockland/images/icons/bullet_list>");
   return %message;
}

function RTBMM_OpenModManager()
{
   $RTB::CModManager::Cache::OpenDirect = 1;
   RTB_Overlay.fadeIn();
   RTB_Overlay.push(RTB_ModManager);
   $RTB::CModManager::Cache::OpenDirect = 0;
}
